<!-- START doctoc generated TOC please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN doctoc TO UPDATE -->
**Table of Contents**  *generated with [DocToc](https://github.com/thlorenz/doctoc)*

- [2 Introduction](#2-introduction)
  - [2.1 Author](#21-author)
  - [2.2 Availability](#22-availability)
  - [2.3 Mailing Lists](#23-mailing-lists)
  - [2.4 The Zsh FAQ](#24-the-zsh-faq)
  - [2.5 The Zsh Web Page](#25-the-zsh-web-page)
  - [2.6 The Zsh Userguide](#26-the-zsh-userguide)
  - [2.7 See Also](#27-see-also)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

<span id="Introduction"></span> <span id="Introduction-1"></span>

# 2 Introduction

<span id="index-introduction"></span>

Zsh is a UNIX command interpreter (shell) usable as an interactive login
shell and as a shell script command processor. Of the standard shells,
zsh most closely resembles ksh but includes many enhancements. It does
not provide compatibility with POSIX or other shells in its default
operating mode: see the section
[Compatibility](Invocation.html#Compatibility).

Zsh has command line editing, builtin spelling correction, programmable
command completion, shell functions (with autoloading), a history
mechanism, and a host of other features.

-----

<span id="Author"></span> <span id="Author-1"></span>

## 2.1 Author

<span id="index-author"></span>

Zsh was originally written by Paul Falstad `<pf@zsh.org>`. Zsh is now
maintained by the members of the zsh-workers mailing list
`<zsh-workers@zsh.org>`. The development is currently coordinated by
Peter Stephenson `<pws@zsh.org>`. The coordinator can be contacted at
`<coordinator@zsh.org>`, but matters relating to the code should
generally go to the mailing list.

-----

<span id="Availability"></span> <span id="Availability-1"></span>

## 2.2 Availability

Zsh is available from the following HTTP and anonymous FTP site.

<span id="index-FTP-sites-for-zsh"></span>
<span id="index-acquiring-zsh-by-FTP"></span>
<span id="index-availability-of-zsh"></span>

`ftp://ftp.zsh.org/pub/`  
`https://www.zsh.org/pub/` )

The up-to-date source code is available via Git from Sourceforge. See
`https://sourceforge.net/projects/zsh/` for details. A summary of
instructions for the archive can be found at
`http://zsh.sourceforge.net/`.

-----

<span id="Mailing-Lists"></span> <span id="Mailing-Lists-1"></span>

## 2.3 Mailing Lists

<span id="index-mailing-lists"></span>

Zsh has 3 mailing lists:

  - `<zsh-announce@zsh.org>`  
    Announcements about releases, major changes in the shell and the
    monthly posting of the Zsh FAQ. (moderated)

  - `<zsh-users@zsh.org>`  
    User discussions.

  - `<zsh-workers@zsh.org>`  
    Hacking, development, bug reports and patches.

To subscribe or unsubscribe, send mail to the associated administrative
address for the mailing list.

`<zsh-announce-subscribe@zsh.org>`

`<zsh-users-subscribe@zsh.org>`

`<zsh-workers-subscribe@zsh.org>`

`<zsh-announce-unsubscribe@zsh.org>`

`<zsh-users-unsubscribe@zsh.org>`

`<zsh-workers-unsubscribe@zsh.org>`

  

YOU ONLY NEED TO JOIN ONE OF THE MAILING LISTS AS THEY ARE NESTED. All
submissions to zsh-announce are automatically forwarded to zsh-users.
All submissions to zsh-users are automatically forwarded to zsh-workers.

If you have problems subscribing/unsubscribing to any of the mailing
lists, send mail to `<listmaster@zsh.org>`. The mailing lists are
maintained by Karsten Thygesen `<karthy@kom.auc.dk>`.

The mailing lists are archived; the archives can be accessed via the
administrative addresses listed above. There is also a hypertext
archive, maintained by Geoff Wing `<gcw@zsh.org>`, available at
`https://www.zsh.org/mla/`.

-----

<span id="The-Zsh-FAQ"></span> <span id="The-Zsh-FAQ-1"></span>

## 2.4 The Zsh FAQ

Zsh has a list of Frequently Asked Questions (FAQ), maintained by Peter
Stephenson `<pws@zsh.org>`. It is regularly posted to the newsgroup
comp.unix.shell and the zsh-announce mailing list. The latest version
can be found at any of the Zsh FTP sites, or at
`http://www.zsh.org/FAQ/`. The contact address for FAQ-related matters
is `<faqmaster@zsh.org>`.

-----

<span id="The-Zsh-Web-Page"></span>
<span id="The-Zsh-Web-Page-1"></span>

## 2.5 The Zsh Web Page

Zsh has a web page which is located at `https://www.zsh.org/`. This is
maintained by Karsten Thygesen `<karthy@zsh.org>`, of SunSITE Denmark.
The contact address for web-related matters is `<webmaster@zsh.org>`.

-----

<span id="The-Zsh-Userguide"></span>
<span id="The-Zsh-Userguide-1"></span>

## 2.6 The Zsh Userguide

A userguide is currently in preparation. It is intended to complement
the manual, with explanations and hints on issues where the manual can
be cabbalistic, hierographic, or downright mystifying (for example, the
word ‘hierographic’ does not exist). It can be viewed in its current
state at `http://zsh.sourceforge.net/Guide/`. At the time of writing,
chapters dealing with startup files and their contents and the new
completion system were essentially complete.

-----

<span id="See-Also"></span> <span id="See-Also-1"></span>

## 2.7 See Also

man page sh(1), man page csh(1), man page tcsh(1), man page rc(1), man
page bash(1), man page ksh(1)

IEEE Standard for information Technology - Part 2: Shell and Utilities,
IEEE Inc, 1993, ISBN 1-55937-255-9.

-----

This document was generated on *February 15, 2020* using
[*texi2html 5.0*](http://www.nongnu.org/texi2html/).  
Zsh version 5.8, released on February 14, 2020.
